//
//  FGHexTextView.m
//  Created by Francesco Germinara on 11/5/05.
//  Freeware 2005
//  www.germinara.it

//Subclass della classe NSTextView per visualizzare il testo in formato ESADECIMALE

#import "FGHexTextView.h"


@implementation FGHexTextView

- (id) init {
	self = [super init];
	if (self != nil) {
	}
	return self;
}


- (void) dealloc {
 [super dealloc];
}

-(void)setSize:(int)nBytes{
  _dimbuffer=(nBytes*3)+1;
}


-(void) awakeFromNib{
  [self setMenu:aMenu];

  [self setSize:256];

  
  bufferdata=[[NSMutableData alloc] initWithLength:_dimbuffer];
  
   memset([bufferdata mutableBytes],'0',_dimbuffer);
  
   int nIndex= 2;
   unsigned char aByte=' ';
   for(nIndex= 2; nIndex<_dimbuffer;nIndex+=3)
    [bufferdata replaceBytesInRange:NSMakeRange(nIndex,1) withBytes:&aByte];

   aByte=0x00;
   [bufferdata replaceBytesInRange:NSMakeRange(_dimbuffer-1,1) withBytes:&aByte];
   
   NSRange location;
   location.length=0;
   location.location=0;
    fntDati=[NSFont fontWithName:@"Courier"size:12.0];
   [self setFont:fntDati];
   [self insertText:[NSString stringWithCString:[bufferdata mutableBytes] encoding:[NSString defaultCStringEncoding]]];
   [offsetposition setStringValue:@""];
  }


 -(void)setAsciiView:( FGAsciiView *)aDataView{
  textDataView=aDataView;

   NSRange location;
   location.length=0;
   location.location=0;
   [self updateData:location];
 }

- (void)mouseDown:(NSEvent *)theEvent{
 [super mouseDown:theEvent];
  NSRange location=[self selectedRange];
  
  if(((unsigned char *)[bufferdata mutableBytes])[location.location]==' '){
   location.location+=1;
  }
 if(location.location >= _dimbuffer-1)
  location.location=_dimbuffer-2;
 [self updateData:location];
}

- (void)keyDown:(NSEvent *)theEvent
{
    NSString *strChar;
	strChar=[theEvent characters];
	
	int nChar=[strChar characterAtIndex:0];

    NSRange location=[self selectedRange];

	if(nChar==NSDeleteFunctionKey || nChar==NSDeleteCharFunctionKey || nChar==0x7F){
	 if(location.location < _dimbuffer){
	  //Se ho premuto cancella 
	  if(location.location>0){
	   if(((unsigned char *)[bufferdata mutableBytes])[location.location-1]!=' '){
	    location.location-=1;
	    ((unsigned char *)[bufferdata mutableBytes])[location.location] ='0';
	   }else{
	 	location.location-=1;
	  }
	  [self updateData:location];
      }
	 }
	 return;  
	}	

	if(nChar==NSDownArrowFunctionKey){
     location.location+=48;
	 if(location.location >= _dimbuffer-3)
	  location.location=_dimbuffer-3;
	 [self updateData:location];
	 return;
	}
	
   if(nChar==NSUpArrowFunctionKey){
     if(location.location>48)
      location.location-=48;
	 else
	  location.location=0;
	 [self updateData:location];
	 return;
	}
	
   if(nChar==NSHomeFunctionKey){
	location.location=0;
	 [self updateData:location];
	 return;
	}

  if(nChar==NSEndFunctionKey){
	location.location=_dimbuffer-3;
	 [self updateData:location];
	 return;
	}

   if(nChar==NSPageUpFunctionKey){
    if(location.location > 1056)
	location.location-= 1056;
	else
	 location.location=0;
    [self updateData:location];
	return;
   }
   
   if(nChar==NSPageDownFunctionKey){
   location.location+= 1056;
    if(location.location >= _dimbuffer-3)
	 location.location=_dimbuffer-3;
	[self updateData:location];
	return;
   }
	
	//Tasti movimento cursore e backspace
	if(nChar==NSLeftArrowFunctionKey || nChar==NSRightArrowFunctionKey){
	 if((location.location >= _dimbuffer-3) && nChar==NSRightArrowFunctionKey)
	  return;
     [super keyDown:theEvent]; 
	 location=[self selectedRange];
	 //Se ho premuto freccia sx o dx e sono su uno spazio ripeto l'evento
	 if(((unsigned char *)[bufferdata mutableBytes])[location.location] == ' '){
	  [super keyDown:theEvent];
	 }
     location=[self selectedRange];
     [offsetposition setStringValue:[NSString stringWithFormat:@"%X Hex - %ld Dec",location.location/3,location.location/3]]; 
     return;	
	}
 	
	//Controllo Range dei valori validi
	//0-0 A-F a-f
	if(!((nChar >='0' && nChar <='9') || (nChar >='A' && nChar <='F') || (nChar >='a' && nChar <='f')))
	 return;

   //Converto tutto in maiuscolo	 
   if(location.location <= _dimbuffer){
	((unsigned char *)[bufferdata mutableBytes])[location.location] = toupper(nChar);
	location.location+=1;
    if(location.location >= _dimbuffer-2)
	 location.location-=1;
	else{ 
	 if(((unsigned char *)[bufferdata mutableBytes])[location.location]==' '){
	  location.location+=1;
 	 }
	}
   }
    
  //Sostituisco il testo
  [self updateData:location];
 }

//Aggiorno dati visualizzati leggendoli dal buffer
-(void)updateData:(NSRange) aRange{  
  [self setString:[NSString stringWithCString:[bufferdata mutableBytes] encoding:[NSString defaultCStringEncoding]]];	
  [self setSelectedRange:aRange];
  [self scrollRangeToVisible:aRange];
  [self updateAsciiView:aRange];
  NSRange location=[self selectedRange];
  [offsetposition setStringValue:[NSString stringWithFormat:@"%X Hex - %ld Dec",location.location/3,location.location/3]]; 
}

-(unsigned char) atoh:(NSString *)strValue{
 int hexValue=0x00;
 char b0=0x00;
 char b1=0x00;
 if([strValue length]!=2) return 0; //error!

 b0=[strValue characterAtIndex:0];
 b1=[strValue characterAtIndex:1];

 if(b0 >='0' && b0 <='9')
  hexValue+=(b0 - '0') * 16;
 if(b0 >='A' && b0 <='F')
  hexValue+=((b0 - 'A')+10) * 16;

 if(b1 >='0' && b1 <='9')
  hexValue+=b1 - '0';
 if(b1 >='A' && b1 <='F')
  hexValue+=(b1 - 'A')+10;

 return (unsigned char) hexValue;
}

- (void)updateAsciiView:(NSRange) aRange
{
  NSString *strHexToAscii;

  NSString *strAsciiValue;
  NSRange range;
  NSMutableString *strResult;
  unsigned char ch=0x00;
  
  strHexToAscii=[[NSString alloc] initWithString:[NSString stringWithCString:[bufferdata mutableBytes] encoding:[NSString defaultCStringEncoding]]];
  strResult =[[NSMutableString alloc] init];
 
  int bytes= [strHexToAscii length];
  int nIndex=0;
  range.location=0;
  range.length=2;
  for(nIndex=1; nIndex<=bytes; nIndex+=3){
   range.location=nIndex-1;
   strAsciiValue=[strHexToAscii substringWithRange:range];
   ch=[self atoh:strAsciiValue];
   [strResult appendFormat:@"%c",(isprint ( ch ) ? ch : 0xFF)];	     
  }
  [textDataView setString:strResult];
  [textDataView setTextToBuffer];
  
  if(aRange.location>=3)
   aRange.location/=3;
  if(aRange.length>=3)
   aRange.length/=3;
  [textDataView setSelectedRange:aRange];
  [textDataView scrollRangeToVisible:aRange];
  [strHexToAscii release];
  [strResult release];
}

-(IBAction) menuSetFF:(id)sender{
  NSRange location=[self selectedRange];
  if(location.length == 0){
   memset([bufferdata mutableBytes],'F',_dimbuffer);
   int nIndex= 2;
   for(nIndex= 2; nIndex<_dimbuffer;nIndex+=3)
    ((unsigned char *)[bufferdata mutableBytes])[nIndex]=' ';
   ((unsigned char *)[bufferdata mutableBytes])[_dimbuffer-1]=0x00;
   location.length=0;
   location.location=0;
   [self updateData:location];
 }else{
  int nBytes=0;
  for(nBytes=0;nBytes<location.length;nBytes++){
   if(((unsigned char *)[bufferdata mutableBytes])[location.location+nBytes]!=' ')
    ((unsigned char *)[bufferdata mutableBytes])[location.location+nBytes]='F';
  }
 [self updateData:location];
 }
 
}

-(IBAction) menuSet00:(id)sender{
  NSRange location=[self selectedRange];
  if(location.length == 0){
   memset([bufferdata mutableBytes],'0',_dimbuffer);
   int nIndex= 2;
   for(nIndex= 2; nIndex<_dimbuffer;nIndex+=3)
    ((unsigned char *)[bufferdata mutableBytes])[nIndex]=' ';
   ((unsigned char *)[bufferdata mutableBytes])[_dimbuffer-1]=0x00;
   location.length=0;
   location.location=0;
   [self updateData:location];
 }else{
  int nBytes=0;
  for(nBytes=0;nBytes<location.length;nBytes++){
   if(((unsigned char *)[bufferdata mutableBytes])[location.location+nBytes]!=' ')
    ((unsigned char *)[bufferdata mutableBytes])[location.location+nBytes]='0';
  }
 [self updateData:location];
 }
 
}


- (void)updateDataFromAscii:(NSRange) aRange withData:(unsigned char*)bufferAscii{
  memset([bufferdata mutableBytes],'0',_dimbuffer);
  int nIndex=0;
  int nIndexAscii=0;
  unsigned char fit[3];
  unsigned ch=0x00;
  for(nIndex= 0,nIndexAscii=0; nIndex<_dimbuffer;nIndexAscii++){
   ch=bufferAscii[nIndexAscii];
   if(isprint (ch))
    sprintf(fit,"%02x",ch);
   else
    strcpy(fit,"00");	
   ((unsigned char *)[bufferdata mutableBytes])[nIndex++]=toupper(fit[0]);
   ((unsigned char *)[bufferdata mutableBytes])[nIndex++]=toupper(fit[1]);
   ((unsigned char *)[bufferdata mutableBytes])[nIndex++]=' ';
  }
  ((unsigned char *)[bufferdata mutableBytes])[_dimbuffer-1]=0x00;
 
  [self setString:[NSString stringWithCString:[bufferdata mutableBytes] encoding:[NSString defaultCStringEncoding]]];	
  [self setSelectedRange:aRange];
  [self scrollRangeToVisible:aRange];
   NSRange location=[self selectedRange];
  [offsetposition setStringValue:[NSString stringWithFormat:@"%X Hex - %ld Dec",location.location/3,location.location/3]]; 
}

- (void)refresh:(unsigned char *) newbuffer withSize:(int)bytes{
  [self clear];
  int nIndex=0;
  int nIndexAscii=0;
  unsigned char fit[3];
  unsigned ch=0x00;
  for(nIndex= 0,nIndexAscii=0; nIndexAscii<bytes;nIndexAscii++){
   ch=newbuffer[nIndexAscii];
   sprintf(fit,"%02x",ch);
   ((unsigned char *)[bufferdata mutableBytes])[nIndex++]=toupper(fit[0]);
   ((unsigned char *)[bufferdata mutableBytes])[nIndex++]=toupper(fit[1]);
   ((unsigned char *)[bufferdata mutableBytes])[nIndex++]=' ';
  }
  ((unsigned char *)[bufferdata mutableBytes])[_dimbuffer-1]=0x00;
  NSRange location;
  location.length=0;
  location.location=0;
  [self updateData:location];  
}

- (void)clear{
   memset([bufferdata mutableBytes],'0',_dimbuffer);
   int nIndex= 2;
   for(nIndex= 2; nIndex<_dimbuffer;nIndex+=3)
    ((unsigned char *)[bufferdata mutableBytes])[nIndex]=' ';
   ((unsigned char *)[bufferdata mutableBytes])[_dimbuffer-1]=0x00;
   NSRange location;
   location.length=0;
   location.location=0;
   [self updateData:location];
}

//Return Buffer Data
-(unsigned char*) getBufferData:(int*) lenBufffer {
 int bufferSize=(_dimbuffer-1)/3;
 unsigned char *rowData=(unsigned char*)calloc(bufferSize,1);
 int nIndex= 0;
 int bIndex= 0; 
 NSString *aTmpStr;
 for(nIndex= 0; nIndex<bufferSize;nIndex++){
  aTmpStr=[NSString stringWithFormat:@"%c%c",((unsigned char *)[bufferdata mutableBytes])[bIndex],((unsigned char *)[bufferdata mutableBytes])[(bIndex+1)]];
  rowData[nIndex]=[self atoh:aTmpStr];
  bIndex+=3;
 }
 (*lenBufffer)=bufferSize;
 return  rowData;
}

-(void)setNewData:(NSData *)data{
 [bufferdata release];
 
 long int  nBytes=[data length];
 long int nIndex=0;
 long int nIndexBufferData=0;
 unsigned char ch=0x00;
 unsigned char fit[2];
 
[self setSize:nBytes];
  
 bufferdata=[[NSMutableData alloc] initWithLength:_dimbuffer];
 
   for(nIndex= 0,nIndexBufferData=0; nIndex<nBytes; nIndex++){
    ch=((unsigned char *)[data bytes])[nIndex];
    sprintf(fit,"%02X",ch);
    ((unsigned char *)[bufferdata mutableBytes])[nIndexBufferData++]=fit[0];
    ((unsigned char *)[bufferdata mutableBytes])[nIndexBufferData++]=fit[1];
    ((unsigned char *)[bufferdata mutableBytes])[nIndexBufferData++]=' ';
  }
  ((unsigned char *)[bufferdata mutableBytes])[nIndexBufferData-1]=0x00;
 
 NSRange location;
  location.length=0;
  location.location=0;
  [self updateData:location];  
}

-(void)setOffSetPositionIndicator:(NSTextField*) aTextField{
 offsetposition = aTextField;
}

@end
